#!/bin/sh

for lines in `cat /etc/motion.cgi.conf`; do
    if [ `echo $lines | cut -d'=' -f1` = "MOTIONBIN" ]; then
	MOTIONBIN=`echo $lines | cut -d'=' -f2`
    fi
done

echo "Content-type: text/html"
echo "max-age: 0"
echo "expires: 0"
echo "pragma: no-cache"
echo "refresh: 10; url="`echo $REQUEST_URI | cut -d'?' -f 1`"?status"
echo

echo "<HTML>"
echo "<BODY bgcolor=white>"
echo "<HR>"

ACTION=`echo $QUERY_STRING | cut -d'?' -f1`

if [ $ACTION = "start" ]; then
    echo "<pre>"
    $MOTIONBIN/motion -D
    echo "</pre>"
    if [ $? = 0 ]; then
	echo "Motion started"
    else
	echo "Could not start motion!"
    fi
fi

if [ $ACTION = "restart" ]; then
    killall -HUP motion
    if [ $? = 0 ]; then
	echo "Successfully instructed motion to restart"
    else
	echo "Failed to instruct motion to restart!"
    fi
fi

if [ $ACTION = "stop" ]; then
    killall -TERM motion
    if [ $? = 0 ]; then
	echo "Motion stopped"
    else
	echo "Could not stop motion!"
    fi
fi

if [ $ACTION = "snapshot" ]; then
    killall -ALRM motion
    if [ $? = 0 ]; then
	echo "Successfully instructed motion to take a snapshot"
    else
	echo "Failed to instruct motion to take a snapshot!"
    fi
fi

if [ $ACTION = "creatempeg" ]; then
    killall -USR1 motion
    if [ $? = 0 ]; then
	echo "Successfully instructed motion to create mpeg movie"
    else
	echo "Failed to instruct motion to create mpeg movie!"
    fi
fi

if [ $ACTION = "status" ]; then
    MOTION_RUNNING="no"
    for process in `ps -axo comm | grep motion`; do
	if [ ! `echo $process | cut -d'.' -f2` = "cgi" ]; then
	    MOTION_RUNNING="yes"
	fi
    done;
    if [ $MOTION_RUNNING = "yes" ]; then
	echo "<B>Status:</B> Motion running"
    else
	echo "<B>Status:</B> Motion not running"
    fi
fi

echo "<HR>"
echo "<P><H6>"
echo "<I>Generated on "`date`" by $SERVER_NAME</I><BR>"
echo "(Updated every 10 seconds)"

echo "</BODY>"
echo "</HTML>"
